Loading...
Searching...
No Matches
Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion > Class Template Reference

a Query implementing AND: requires any child to be `true` More...

`#include <OrQuery.h>`

Inheritance diagram for Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >:

## Public Types

typedef Query< MatchFuncArgType, DataFuncArgType, needsConversion > | BASE
Public Types inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
using | CHILD_TYPE
using | CHILD_VECT
using | CHILD_VECT_I
using | CHILD_VECT_CI
using | MATCH_FUNC_ARG_TYPE
using | DATA_FUNC_ARG_TYPE

## Public Member Functions

| OrQuery ()
bool | Match (const DataFuncArgType what) const override
Query< MatchFuncArgType, DataFuncArgType, needsConversion > * | copy () const override
| returns a copy of this Query
Public Member Functions inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
| Query ()
virtual | ~Query ()
void | setNegation (bool what)
| sets whether or not we are negated
bool | getNegation () const
| returns whether or not we are negated
void | setDescription (const std::string &descr)
| sets our text description
const std::string & | getDescription () const
| returns our text description
virtual std::string | getFullDescription () const
| returns a fuller text description
void | setTypeLabel (const std::string &typ)
| sets our type label
const std::string & | getTypeLabel () const
| returns our text label.
void | setMatchFunc (bool(*what)(MatchFuncArgType))
| sets our match function
void | setDataFunc (MatchFuncArgType(*what)(MatchFuncArgType))
| sets our data function
void | addChild (CHILD_TYPE child)
| adds a child to our list of children
CHILD_VECT_CI | beginChildren () const
| returns an iterator for the beginning of our child vector
CHILD_VECT_CI | endChildren () const
| returns an iterator for the end of our child vector
virtual bool | Match (const MatchFuncArgType arg) const
| returns whether or not we match the argument

## Additional Inherited Members

Public Attributes inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
bool(*)(MatchFuncArgType) | getMatchFunc () const
| returns our match function:
MatchFuncArgType(*)(MatchFuncArgType) | getDataFunc () const
| returns our data function:
MatchFuncArgType(* | d_dataFunc )(MatchFuncArgType)
MatchFuncArgType(* | d_dataFuncSameType )(MatchFuncArgType)
Protected Member Functions inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
MatchFuncArgType | TypeConvert (MatchFuncArgType what, Int2Type< false >) const
| calls our `dataFunc` (if it's set) on `what` and returns the result, otherwise returns `what`
Protected Attributes inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
MatchFuncArgType | d_val
MatchFuncArgType | d_tol
std::string | d_description
std::string | d_queryType
CHILD_VECT | d_children
bool | df_negate
bool(* | d_matchFunc )(MatchFuncArgType)
union { |
MatchFuncArgType(* d_dataFunc )(DataFuncArgType) |
MatchFuncArgType(* d_dataFuncSameType )(MatchFuncArgType) |
}; |

## Detailed Description

template<class MatchFuncArgType, class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>
class Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >

a Query implementing AND: requires any child to be `true`

Definition at line 20 of file OrQuery.h.

## Member Typedef Documentation

## BASE

template<class MatchFuncArgType, class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

typedef Query<MatchFuncArgType, DataFuncArgType, needsConversion> Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::BASE

Definition at line 23 of file OrQuery.h.

## Constructor & Destructor Documentation

## OrQuery()

template<class MatchFuncArgType, class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::OrQuery | ( |  | ) |

inline

Definition at line 24 of file OrQuery.h.

## Member Function Documentation

## copy()

template<class MatchFuncArgType, class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

Query< MatchFuncArgType, DataFuncArgType, needsConversion > * Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::copy | ( |  | ) | const

inline override virtual

returns a copy of this Query

Notes:

- the caller is responsible for deleteing the result

Reimplemented from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >.

Definition at line 42 of file OrQuery.h.

## Match()

template<class MatchFuncArgType, class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

bool Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::Match | ( | const DataFuncArgType | what | ) | const

inline override

Definition at line 26 of file OrQuery.h.

The documentation for this class was generated from the following file:

- OrQuery.h